//+------------------------------------------------------------------+
//|                                                       SMARSI.mq4 |
//|                          Typical RSI revised By TrendLaboratory  |
//|            http://finance.groups.yahoo.com/group/TrendLaboratory |
//|                                       E-mail: igorad2004@list.ru |
//+------------------------------------------------------------------+
#property copyright "Copyright  2005, TrendLaboratory Ltd."
#property link      "http://finance.groups.yahoo.com/group/TrendLaboratory"

#property indicator_separate_window
#property indicator_minimum 0
#property indicator_maximum 100
#property indicator_level1 30
#property indicator_level2 70
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Yellow
//---- input parameters
extern int RSIPeriod=6;
extern int MAPeriod=3;
extern string MAMethod = "SMA";
int _MAMethod = 0;
extern int Price=0;
extern int Smooth=2;
//---- buffers
double RSIBuffer[];
double SmoothBuffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  if(MAMethod == "SMMA") _MAMethod = MODE_SMMA;
  else if(MAMethod == "SMA") _MAMethod = MODE_SMA;
  else if(MAMethod == "EMA") _MAMethod = MODE_EMA;
  else if(MAMethod == "LWMA") _MAMethod = MODE_LWMA;
  else _MAMethod = MODE_SMA;
  
   string short_name;

   IndicatorBuffers(2);
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,RSIBuffer);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,SmoothBuffer);
//---- name for DataWindow and indicator subwindow label
   short_name="RSI("+RSIPeriod+","+MAPeriod+","+Price+","+Smooth+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
   SetIndexLabel(1,"Smooth");
//----
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS)+4);

   SetIndexDrawBegin(0,RSIPeriod+Smooth);
   SetIndexDrawBegin(0,RSIPeriod+Smooth);
//----
   return(0);
  }


////////////////////////////////////////////////////////////////////////////////
// Relative Strength Index

// ret=0 - RSIBuffer
// ret=1 - SmoothBuffer
// otherwise -1 returned

double rsi(int timeframe, double RSIPeriod, double MAPeriod, int MAMethod, double Price, double Smooth, int ret, int shift){
 if(ret == 0) return (rsiBuff(timeframe, RSIPeriod, MAPeriod, MAMethod, Price, shift));
 else if(ret != 1) return(-1);
 
 double sumn=0, sump=0, rel, positive, negative, AvgRange=0;
 for(int k = Smooth-1; k>=0; k--){
  AvgRange += rsiBuff(timeframe, RSIPeriod, MAPeriod, MAMethod, Price, shift+k);
 }
 return (AvgRange/Smooth);
}

double rsiBuff(int timeframe, double RSIPeriod, double MAPeriod, int MAMethod, double Price, int shift){
 double sumn=0, sump=0, rel, positive, negative;
  
 for (int k = RSIPeriod-1; k >= 0; k--){ 
  rel = iMA(Symbol(), timeframe, MAPeriod, 0, MAMethod, Price, shift+k)/Point -
        iMA(Symbol(), timeframe, MAPeriod, 0, MAMethod, Price, shift+k+1)/Point;
  if(rel > 0) sump += rel;
  else sumn -= rel;
 }
 
 positive = sump/RSIPeriod/Point;
 negative = sumn/RSIPeriod/Point;
 
 if(negative == 0) return(100);
 else return(100 - 100/(1 + positive/negative));
}
//
////////////////////////////////////////////////////////////////////////////////////////

int start(){
 int    i,counted_bars=IndicatorCounted();
   
   //Comment(" Digits = ", MarketInfo(Symbol(),MODE_DIGITS));
   if(Bars<=RSIPeriod+Smooth) return(0);
   
//initial zero
   if(counted_bars<1)
      for(i=1;i<=RSIPeriod+Smooth;i++) RSIBuffer[Bars-i]=0.0;

   i=Bars-RSIPeriod-Smooth-1;
   if(counted_bars>=RSIPeriod+Smooth) i=Bars-counted_bars-1;
   while(i>=0){
     RSIBuffer[i] = rsi(0, RSIPeriod, MAPeriod, _MAMethod, Price, Smooth, 0, i);
     SmoothBuffer[i] = rsi(0, RSIPeriod, MAPeriod, _MAMethod, Price, Smooth, 1, i);
     i--;
   }

   return(0);
  }
//+------------------------------------------------------------------+